#ifndef __parameters_h__
#define __parameters_h__

class ParameterFile {
private:
  const static int MAX_CATEGORIES = 2000;
  const static int MAX_DEFINITIONS = 10000;
  char paramFileName[200];
  char categoryName[MAX_CATEGORIES][50];
  int selectedCategory;
  int numCategories;
  struct {
    int categoryIndex;
    char name[50];
    char value[200];
    bool accessed;
  } definition[MAX_DEFINITIONS];
  int numDefinitions;
  
public:
  ParameterFile(const char *filename);
  bool selectSection(const char *newCategory);
  bool existsSetting(const char *name);
  int getAsInt(const char *name);
  double getAsDouble(const char *name);
  void getAsString(const char *name, char *buf, int bufsize);
  bool getAsBoolean(const char *name);
  int numSettingsInSection();
  void getSettingByIndex(int index, char **name, char **value);
  void assertAllAccessed();
  void write(const char *filename);
  void set(const char *setCategory, const char *setName, const char *setValue);
};

#endif /* defined(__parameters_h__) */
